/* Projekt Name: InfoOS
 * Licensed under the GPL (General Public License)
 * Written by Sebastian Tilders
 */
// Dieser Header definiert die Multiboot - Headerstrukturen, die für den Kernel nützlich sind.
#ifndef _h_multiboot
#define _h_multiboot
/* Definition */
struct multiboot
{
	// Platzhalter :D
	uint32_t mbs_flags;				// Multiboot Flags
	uint32_t mbs_mem_lower;			// Größe des unteren Speichers (Low-Memory)
	uint32_t mbs_mem_upper;			// Größe des oberen Speichers (High-Memory)
	uint32_t mbs_bootdevice;		// Laufwerk von dem gebootet wurde.
	uint32_t* mbs_cmdline;			// Übergebene Kommandos an den Kernel
	uint32_t mbs_mods_count;		// Geladene Kernel-Module (Grub Module)
	uint32_t mbs_mods_addr;		// Adresse zur Modul-Struktur
	uint64_t mbs_syms_high;				// Binärinformationen zur //Kernel-Datei
	uint64_t mbs_syms_low;
	uint32_t mbs_mmap_length;		// Länge der Memory-Map die von Grub/Bios angelegt wurde.
	uint32_t mbs_mmap_addr;		// Adresse zur Memory-Map Struktur
	uint32_t mbs_drives_length;		// Länge der Laufwerksliste
	uint32_t* mbs_drives_addr;		// Adresse zur ersten Laufwerksstruktur
	uint32_t mbs_config_table;
	uint32_t* mbs_boot_loader_name;	// Name des Bootloaders
	uint32_t* mbs_apm_table;		// Adresse zur APM Tabelle
	uint32_t mbs_vbe_control_info;
	uint32_t mbs_vbe_mode_info;
	uint16_t mbs_vbe_mode;
	uint16_t mbs_vbe_interface_seg;
	uint16_t mbs_vbe_interface_off;
	uint16_t mbs_vbe_interface_len;
};

// Memory-Map Struktur
struct mbs_mmap
{
	uint32_t size;
	uint64_t BaseAddr;
	uint64_t Length;
	uint32_t Type;
};
// Drive Map !!EXPERIMENTELL!!
struct mbs_drives
{
	uint32_t size;
	uint32_t drive_number; // BIOS Geräte Nummer
	uint32_t drive_mode; // (0) CHS oder (1) LBA
	uint32_t drive_cylinders;
	uint32_t drive_heads;
	uint32_t drive_sectors;
	// drive_ports (variable größe ?!)!
};
// Ende
#endif