/*
 * Written by Sebastian Tilders
 * Licensed under the GPL (General Public License)
 * Projekt-Name: InfoOS
 */
#include "../header/typedefs.h"
#include "../header/display.h"
#include "../header/string.h"
#include "../header/gdt.h"
#include "../header/timer.h"
#include "../header/task.h"
#include "../header/pmm.h"
uint8_t* set_timer(uint16_t vticks);
uint16_t create_task(uint8_t* process, uint16_t ring);
void init_multi(void);
// INIT Kernel
void test_print(void)
{
while(1){delay(15); print("Hello this is test_print();\n\r", DSP_COLOR_YELLOW);}
}
void multi_init(void)
{
  delay(30);
  cls();
  print("Welcome to ",DSP_COLOR_WHITE);
print("Infortus - LiveCD\n\r",DSP_COLOR_LIGHTBLUE);
print("Bootstrapping - PHASE 2 of 3\n\r", DSP_COLOR_LIGHTGREEN);
print("-------------------------\n\rWritten by Sebastian Tilders\n\r",DSP_COLOR_WHITE);
print("Free Memory: ", DSP_COLOR_BLUE);
print(int2hex_ascii(free_memory()),DSP_COLOR_GREEN);
print(" Bytes\n\r", DSP_COLOR_GREEN);
print("Starte Multitasking...", DSP_COLOR_GRAY);
  delay(50);
 create_task((uint8_t*)&test_print,3);
 print(" [Done]\n\r", DSP_COLOR_GREEN);
 print("DEBUG Message: Test Multitasking:\n\r", DSP_COLOR_YELLOW);
 while(1){delay(5); print("This is multi_init();\n\r",DSP_COLOR_LIGHTRED);}
}
void init(struct multiboot* mb_header)
{
cls();
print("Welcome to ",DSP_COLOR_WHITE);
print("Infortus - LiveCD\n\r",DSP_COLOR_LIGHTBLUE);
print("Bootstrapping - PHASE 1 of 3\n\r", DSP_COLOR_LIGHTGREEN);
print("-------------------------\n\rWritten by Sebastian Tilders\n\r",DSP_COLOR_WHITE);
pmm_init(mb_header);
print("Writing GDT entries...", DSP_COLOR_GRAY);
setup_gdt();
print(" [Done]\n\r", DSP_COLOR_GREEN);
print("Writing IDT entries...", DSP_COLOR_GRAY);
// IDT Einträge festlegen IRQ 1 - 15	
setup_idt();
print(" [Done]\n\r",DSP_COLOR_GREEN);
print("Programming the PIC...", DSP_COLOR_GRAY);
setup_pic();
print(" [Done]\n\r", DSP_COLOR_GREEN);
print("Stepping to Phase 2...",DSP_COLOR_GRAY);
init_multi();
create_task((uint8_t*)&multi_init, 3);
return;
}