/*
 * Written by Sebastian Tilders
 * Licensed under the GPL (General Public License)
 * Project Name: InfoOS
 */
#include "../header/interrupts.h"
#include "../header/gdt.h"
struct task_state_segment
{
  uint32_t previous_task_link;
  // esp 0 - 2 ; ss 0 - 2 
  uint32_t esp0;
  uint32_t ss0;
  uint32_t esp1;
  uint32_t ss1;
  uint32_t esp2;
  uint32_t ss2;
  // Control Register 3
  uint32_t cr3;
  // Code-zeiger
  uint32_t eip;
  // Flags
  uint32_t eflags;
  // Allzweck Register
  uint32_t eax;
  uint32_t ecx;
  uint32_t edx;
  uint32_t ebx;
  uint32_t esp;
  uint32_t ebp;
  // String-Register
  uint32_t esi;
  uint32_t edi;
  // Datensegmente
  uint32_t es;
  uint32_t cs;
  uint32_t ss;
  uint32_t ds;
  uint32_t fs;
  uint32_t gs;
  // Spezial
  uint32_t ldt_selektor;
  uint32_t io_map_base_adress;
};
struct cpu_state* schedule(struct cpu_state* cpu);
extern struct task_state_segment tss;
struct cpu_state* handle_interrupt(struct cpu_state* cpu)
{
if(cpu->intr == 0x2F)
{
asm volatile("cli");
print("INTERUPT 0x2F: SYSCALL\n\r", DSP_COLOR_BLUE);
asm volatile("sti");
while(1) {}
}
if(cpu->intr <= 0x1f)		// wenn kleiner als 31 ist es eine Exeception
{
	print("Exception: ",DSP_COLOR_RED);
	print(int2ascii(cpu->intr), DSP_COLOR_RED);
	print(" \n\rKernel Angehalten!", DSP_COLOR_RED);
	while(1)
	{
		asm volatile("cli;hlt");
	}
	// return 0;
}
else			// Andernfalls Schedulen
{
tss.ss0 = 0x10;
struct cpu_state* new_cpu = cpu;
if(cpu->intr == 0x20)
{
check_timer();
new_cpu = schedule(cpu);
tss.esp0 = (unsigned long) (new_cpu + 1);
}
// Bei Hardware Interrupts EOI senden.
if (cpu->intr >= 0x20 && cpu->intr <= 0x2f) {
    if (cpu->intr >= 0x28) {
        outb(0xa0, 0x20);
    }
    outb(0x20, 0x20);
}
return new_cpu;
}
}